
var PageSelection = "";
var PageURL = "";
var PageHost = "";
var LinkURL = "";
var cqrAction = "";
var cqrActionPrompt = "";
var ConfigLastWillId = "";
var ConfigLastWillCtrl = false;
var cqrTabRef = "";
var cqrWndRef = "";


/// HotMenu. Many thanks to Henrik Gulbrandsen for developing this!
function RegisterContextMenuListener(){
  getBrowser().addEventListener("contextmenu", HandleContextMenu, true);
}

function HandleInsertedNode(event){
// somehow this sub breaks up the top menu ("File", "Edit" e.t.c) of Mozilla 1.7a, bild 2004010508
// ...and somehow HotMenu works without this :))
//  if (event.target.id == "content"){
//    RegisterContextMenuListener();
//  } 
}

document.addEventListener("DOMNodeInserted", HandleInsertedNode, false);
RegisterContextMenuListener();

function HandleContextMenu(event){
  //[:linkurl] Thanks Biju G C for idea and pointing me to findParentNode()
  LinkURL = findParentNode(event.originalTarget, "a");
  if (!LinkURL) LinkURL = "";

  Shift = event.shiftKey;
  prfs_LoadMain();
  if ((Shift == true) && (UseHotMenu)){
    var box = getBrowser().boxObject;
    MouseX = event.screenX - box.screenX + box.x;
    MouseY = event.screenY - box.screenY + box.y;

    document.popupNode = event.target;
    event.preventDefault();
    hotmenu(Shift);
  } else {FillMenu(Shift)}
}

function hotmenu(Shift){
try{
  var hotmenu = document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    document.documentElement.appendChild(hotmenu);
  }
  FillMenu(Shift);
  hotmenu.showPopup(getBrowser(), MouseX + 2, MouseY + 2, "context", "bottomleft", "topleft");
}catch(er){cqerr(er, "hotmenu sub")}
}
//EOf HotMenu

function FillMenu(Shift, allshowif){
try{
	lastDirState = rdir(PlugsDir);
  getPageParams();
	if (srcupdated()) {
  	plg_QuickLoadAll();
  }
  prfs_UpdateEntries();

  var recommend = [];
  var ppMenu = document.getElementById("cq-ppm");
	if ((Shift) && (UseHotMenu)) {
    ppMenu = document.getElementById("cq-hotmenu");
  } else {
    //ppMenu = document.getElementById("cq-ppm");
  }
	while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  var entries = EntryHash._Items();
  for (entry in entries){
    if (entries[entry].blocked) continue;
	  if (entries[entry].Context){
		  var ppItem = document.createElement("menuitem");
		  ppItem.setAttribute("class", "menuitem-iconic");
	      //alert(entries[entry].iconpath);
	      ppItem.setAttribute("image", "file://" + entries[entry].iconpath);
		  ppItem.setAttribute("label", "   " + entries[entry].Title);
		  ppItem.setAttribute("tooltiptext", "Hold Ctrl to tune it up");
		  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[entry].eId+"')");
		  ppMenu.appendChild(ppItem);
		}//else{
	  if (entries[entry].showif){
	    re = new RegExp(entries[entry].showif,"im");
	    trg = SubstVars(entries[entry].sitarget, entries[entry]);
	    //res = re.exec(PageSelection);
	    res = re.exec(trg);
	    if (res || allshowif){
	      EntryHash[entries[entry].eId].lastmatch = res;
  	    if (!entries[entry].Context) recommend[entry]="";
	    } else {
	      EntryHash[entries[entry].eId].lastmatch = [];
	      EntryHash[entries[entry].eId].lastmatch[0] = trg;
	    }
		}
//		}
  }
  if (recommend.length){
    ppMenu.appendChild(document.createElement("menuseparator"));
    for (each in recommend){
  	  var ppItem = document.createElement("menuitem");
  	  ppItem.setAttribute("label", entries[each].Title);
  	  ppItem.setAttribute("tooltiptext", "Hold Ctrl to tune it up");
  	  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[each].eId+"')");
  	  ppMenu.appendChild(ppItem);
    }
  }
}catch(er){cqerr(er, "FillMenu sub")}
}

function detecttrg(evnt){
 if (evnt.originalTarget.localName == "menuseparator") FillMenu(false,true);
}

function ProcessEntry(ctrl, EntryId){
	//getPageParams();
	var entry = EntryHash._Item(EntryId);
	if (ctrl) ShowAlternatives = true;
	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = plg_ReadData(entry.filepath);
        entry.Context = EntryHash[EntryId].Context;
        entry.lastmatch = EntryHash[EntryId].lastmatch;
		EntryHash._AddEntryObj(entry, entry.eId);
	}
  PrepareAction(entry);
	if (cancel){
		resetenv();
		return;
	}

  if (MailFlag){
    //cqrWndRef = window.open("about:blank", "", "chrome=yes,all,resizable,width=1,height=1");
    //cqrWndRef = window.open("about:blank", "", "chrome");
    //alert(MailFlag);
    //doc = wnd.document;
    
    //var browser = getBrowser();
    //alert(window.document);
  } else {
    var browser = getBrowser();
    if ((cqrAction) && (!entry.Inputs)){
      tab = browser.addTab(cqrAction);
      if (!LoadTabsInBg) browser.selectedTab = tab;
      resetenv();
      return;
    }
   	
    myTabRef = browser.addTab();
  	//tabBr = browser.getBrowserForTab(tab);
  	//tabBr = browser.getBrowserForTab(browser.mTabContainer.lastChild);
  	if (!LoadTabsInBg) browser.selectedTab = myTabRef;
  }
  
  window.setTimeout('formIt("'+ EntryId + '");', 100);
}

function formIt(EntryId){
var entry = EntryHash._Item(EntryId);
  if (MailFlag){
    //doc = cqrWndRef.document;
    doc = window.document;
  } else {
    tabBr = getBrowser().getBrowserForTab(myTabRef);
    doc = tabBr.contentDocument;
  }

try{
  var frm = doc.createElementNS("http://www.w3.org/1999/xhtml", "form");
  frm.setAttribute("name", "cqrform");
  if (entry.Action){
    frm.setAttribute("action", cqrAction);
  } else {
    frm.setAttribute("action", entry.Action);
  }
  frm.setAttribute("method", entry.Method);
  frm.setAttribute("style", "display: none;");
  frm.setAttribute("accept-charset", entry.qcharset);
  if (MailFlag) frm.setAttribute("target", "_blank");
  for (each in QueryHash){
    var inp = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
      inp.setAttribute("type", "hidden");
      inp.setAttribute("name", each);
      inp.setAttribute("value", QueryHash[each]);
      frm.appendChild(inp);
  }
  doc.documentElement.appendChild(frm);
  frm.submit();
  //if (MailFlag) cqrWndRef.close();
  resetenv();
}catch(er){cqerr(er, "ProcessEntry sub")}
}

function PrepareAction(EntryObj){
try{
  cqrAction = SubstVars(EntryObj.Action);
  for (i in EntryObj.Inputs){
    QueryHash[EntryObj.Inputs[i].def.name] = SubstVars(EntryObj.Inputs[i].def.value, EntryObj);
  }
  if (ShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function SubstVars(str, EntryObj){
    var retstr = "";
    ire = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");
    cqrvars = ire.exec(str);
    lastind = 0;
    if (cqrvars){
      while (cqrvars){
        tmpstr = str.substring(lastind, ire.lastIndex);
        switch("[:"+cqrvars[1]+"]"){
          case "[:selection]":
            if (!PageSelection) ShowAlternatives=true;
            retstr += tmpstr.replace("[:selection]", PageSelection);
            break;
          case "[:url]":
            retstr += tmpstr.replace("[:url]", PageURL);
            break;
          case "[:linkurl]":
            retstr += tmpstr.replace("[:linkurl]", LinkURL);
            break;
          case "[:host]":
            retstr += tmpstr.replace("[:host]", PageHost);
            break;
          case "[:text]":
            retstr += tmpstr.replace("[:text]", "");
            break;
          case "[:matched]":
            var matchnum = Number(cqrvars[3]);
            if (isNaN(matchnum)) matchnum = 0;
            if (EntryObj.lastmatch[matchnum]){
              retstr += tmpstr.replace(cqrvars[0], EntryObj.lastmatch[matchnum]);
            }else{
              retstr += tmpstr.replace(cqrvars[0], "");
            }
            break;
          case "[:prompt]":
            ShowAlternatives=true;
            retstr += tmpstr.replace("[:prompt]", "");
            break;
          //if variable is not recognized
          default:
            retstr += tmpstr;
        }
      //if (cqrvars) show(str + ">>>>>>>" + cqrvars[0]);
      //ire.lastIndex = 0;
      lastind = ire.lastIndex;
      cqrvars = ire.exec(str);
      }
      retstr += str.substring(lastind);
    } else {retstr = str}
    return retstr;
}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", "ConQuery config",	"centerscreen,chrome,modal,resizable=yes");
  if (ConfigLastWillId){
    ProcessEntry(ConfigLastWillCtrl, ConfigLastWillId);
    ConfigLastWillId = "";
  }
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		PageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){PageSelection=""}
  
  try{
  	PageURL = focusedWindow.location.href;
	}catch(er){PageURL=""}
	
	try{
	  	PageHost = focusedWindow.location.host;
	}catch(er){PageHost=""}
}

function resetenv(){
	QueryHash = new Object();
	PageSelection = "";
	PageURL = "";
	PageHost = "";
	LinkURL = "";
	cqrAction = "";
	ConfigLastWillId = "";
	ConfigLastWillCtrl = false;
	ShowAlternatives = false;
	cancel = false;
	cqrTabRef = "";
	cqrWndRef = "";
}
